---
kernelspec:
  name: python3
  display_name: 'Python 3'
---

# Exercise 1: dispatching a function to C++

**Authors:** Tiago P. Peixoto<sup>1</sup> \
**Affiliations:** <sup>1</sup>Inverse Complexity Lab \
**License:** CC-BY

Take a look at the template below (available from the manual
[repo](https://git.skewed.de/invcomplexity/lab-manual); no need to copy and
paste.)

The first file defines a C++ function that receives a graph and a property map,
and just prints its values.

```{include} example.hh
:filename:  example.hh
:lang: cpp
```

The second file is a compilation unit that dispatches the function above to the
appropriate type, depending on what has been received from the Python interpreter.

```{include} example.cc
:filename:  example.cc
:lang: cpp
```

The third file is a Python file that binds a function to the its C++
implementation defined above:

```{include} example.py
:filename:  example.py
:lang: python
```

Finally, the ``Makefile`` below facilitates the compilation:

```{include} Makefile
:filename:  Makefile
:lang: make
```

We need to compile the C++ code by typing ``make``:

```bash
$ make
```
```{code-cell} python
:tags: [remove-input]
!make
```
Now we are ready to call the function above from Python:

```{code-cell} python
from graph_tool.all import *
from example import example

g = collection.data["dolphins"]

example(g, g.vertex_index);
```

# Task 1: Modify the code above to store the number of second neighbors to the property map.

- Thomas ([repo](https://git.skewed.de/thomasrobiglio/exercises_retreat/-/tree/main/task1?ref_type=heads))
- Martina ([repo](https://git.skewed.de/mcontisciani/lab-manual/-/tree/master/gt-workbench/solution1?ref_type=heads))
- Max ([repo](https://git.skewed.de/fractalfalken/lab-manual-exercises/-/tree/task1/gt-workbench/exercise1/task1?ref_type=heads))
- Basti ([repo](https://git.skewed.de/bastikusch1/workshop-exercises))

- Bukyoung ([tast1.hh](https://git.skewed.de/bukyoungjhun/traunsee/-/blob/main/exercise1/task1.hh) [task1.cc](https://git.skewed.de/bukyoungjhun/traunsee/-/blob/main/exercise1/task1.cc))

# Task 2: Modify the code above to store for each vertex a vector with the 10 closest neighbors.

- Max ([repo](https://git.skewed.de/fractalfalken/lab-manual-exercises/-/tree/task1/gt-workbench/exercise1/task2?ref_type=heads))

Add your solution here as a link to a gitlab repository.

# Task 3: Modify the code above to store the PageRank to the property map.

Add your solution here as a link to a gitlab repository.

# Task 4: Modify the code above so that the function returns true if the graph is bipartite.

Add your solution here as a link to a gitlab repository.

# Task 5: Modify the code above so that the function returns performs some computation if the graph is undirected and another if it is directed.

Add your solution here as a link to a gitlab repository.
