#include "graph_tool.hh"

#include "idx_map.hh"

#include <iostream>

using namespace graph_tool;
using namespace boost;
using namespace std;

template <typename Graph, typename VMap>
void example(Graph& g, VMap vmap)
{
    idx_set<size_t> us, ws;
    for (auto v : vertices_range(g))
    {
        for (auto u : adjacent_vertices_range(v, g))
            us.insert(u);
        for (auto u : adjacent_vertices_range(v, g))
        {
            for (auto w : adjacent_vertices_range(u, g))
            {
                if (us.find(w) != us.end())
                    continue;
                ws.insert(w);
            }
        }
        vmap[v] = ws.size();

        us.clear();
        ws.clear();
    }
}
