#include <boost/python.hpp>

#include "example.hh"

using namespace boost;
using namespace graph_tool;

GEN_DISPATCH(example_state, ExampleState, EXAMPLE_STATE_params)

python::object make_example_state(boost::python::object ostate)
{
    python::object state;
    example_state::make_dispatch(ostate,
                                  [&](auto& s){state = python::object(s);});
    return state;
}

#define __MOD__ example
#define DEF_REGISTRY
#include "module_registry.hh"

BOOST_PYTHON_MODULE(libexample)
{
    using namespace boost::python;
    def("make_example_state", &make_example_state);

    example_state::dispatch
        ([&](auto* s)
         {
             typedef typename std::remove_reference<decltype(*s)>::type state_t;
             class_<state_t, bases<>, std::shared_ptr<state_t>>
                 c(name_demangle(typeid(state_t).name()).c_str(),
                   no_init);
             c.def("virtual_move", &state_t::virtual_move)
                 .def("move_vertex", &state_t::move_vertex)
                 .def("entropy", &state_t::entropy);
         });

    class_<eargs_t>("eargs")
        .def_readwrite("param1", &eargs_t::param1)
        .def_readwrite("param2", &eargs_t::param2);

    __MOD__::EvokeRegistry();
}
